unit IPServerContaineru;

interface

uses
  SysUtils, Classes, 
  DSTCPServerTransport,
  DSServer, DSCommonServer, DSAuth; 

type
  TServerContainer1 = class(TDataModule)
    DSServer1: TDSServer;
    DSTCPServerTransport1: TDSTCPServerTransport;
    DSServerClass1: TDSServerClass;
    procedure DSServerClass1GetClass(DSServerClass: TDSServerClass;
      var PersistentClass: TPersistentClass);
  private
    { Private declarations }
  public
    {$IFDEF DEBUG}
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    {$ENDIF}
  end;

var
  ServerContainer1: TServerContainer1;

implementation

uses Windows, IPServerMethodsu;

{$R *.dfm}

{$IFDEF DEBUG}
constructor TServerContainer1.Create(AOwner: TComponent);
begin
  inherited;
  outputdebugstring(PChar('Starting the server container'));
end;

destructor TServerContainer1.Destroy;
begin
  outputdebugstring(PChar('stopping the server container'));
  inherited;
end;
{$ENDIF}

procedure TServerContainer1.DSServerClass1GetClass(
  DSServerClass: TDSServerClass; var PersistentClass: TPersistentClass);
begin
  PersistentClass := IPServerMethodsu.TServerMethods1;
end;

end.

